﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq

Public Class ClaimDAO

    Private attrMyConnString As String
    Property MyConnString() As String
        Get
            Return attrMyConnString
        End Get
        Set(ByVal Value As String)
            attrMyConnString = Value
        End Set
    End Property

    Public Sub New()
        myConnString = ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString
    End Sub

    Public Function getClaimList() As List(Of Claim)
        Return getClaimList(Nothing)
    End Function

    ' fetch list of claims which have not yet been approved 
    Public Function getClaimList(ByVal whereClause As String) As List(Of Claim)
        If IsNothing(whereClause) Then
            whereClause = ""
        End If
        Dim foundClaims As List(Of Claim) = New List(Of Claim)
        Dim myConn As SqlConnection = New SqlConnection(myConnString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM claim " + whereClause
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        While myDR.Read()
            foundClaims.Add(makeDTO(myDR))
            ' create new DTO and add to list 
        End While
        Return foundClaims
    End Function

    ' fetch a claim by ID or key
    Public Function getClaim(ByVal claimKey As Integer) As Claim
        Dim myConn As SqlConnection = New SqlConnection(myConnString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM claim WHERE (claimID=" _
            + claimKey.ToString() + ")"
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        If myDR.Read() = False Then
            Return Nothing
        End If
        Return makeDTO(myDR)
    End Function

    ' fetch a claim by reference number (the first one to match) 
    Public Function getClaimByRef(ByVal claimRef As String) As Claim
        Dim myConn As SqlConnection = New SqlConnection(myConnString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM claim WHERE (reference='" _
            + claimRef + "')"
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDr As SqlDataReader = myComm.ExecuteReader()
        If myDr.Read() = False Then
            Return Nothing
        End If
        Dim myClaim As Claim = makeDTO(myDr)
        Return myClaim
    End Function

    ' helper method 
    Private Function makeDTO(ByVal myDR As SqlDataReader) As Claim
        Dim myClaim As Claim = New Claim()
        myClaim.ClaimID = myDR.GetInt32(0)
        myClaim.Reference = myDR.GetString(1)
        myClaim.Description = myDR.GetString(2)
        myClaim.Amount = myDR.GetDecimal(3)
        myClaim.IsApproved = myDR.GetString(4).StartsWith("Y")
        myClaim.DateOfClaim = myDR.GetDateTime(5)
        myClaim.PolicyID = myDR.GetInt32(6)
        Return myClaim
    End Function

    ' save a claim object to the database 
    Public Sub saveClaim(ByVal myClaim As Claim)
        Dim isApproved As Char = "N"
        If myClaim.IsApproved Then
            isApproved = "Y"
        End If
        Dim claimDate As String = myClaim.DateOfClaim.Day.ToString() + "/" + myClaim.DateOfClaim.Month.ToString() + "/" + myClaim.DateOfClaim.Year.ToString()
        Dim myConn As SqlConnection = New SqlConnection(myConnString)
        myConn.Open()
        Dim insertString As String = "INSERT INTO claim (reference, description, amount, approved, claimDate, policyID) " + _
            "VALUES(@reference, @description, @amount, @approved, @claimDate, @policyID)"
        Dim myComm As SqlCommand = New SqlCommand(insertString, myConn)

        myComm.Parameters.AddWithValue("@reference", myClaim.Reference)
        myComm.Parameters.AddWithValue("@description", myClaim.Description)
        myComm.Parameters.AddWithValue("@amount", myClaim.Amount)
        myComm.Parameters.AddWithValue("@approved", isApproved)
        myComm.Parameters.AddWithValue("@claimDate", myClaim.DateOfClaim)
        myComm.Parameters.AddWithValue("@policyID", myClaim.PolicyID)

        Dim rows As Integer = myComm.ExecuteNonQuery()
        myConn.Close()
        If rows <> 1 Then
            Throw New Exception("Unexpected Result for Insert")
        End If
    End Sub

    ' update claim object in the database 
    Public Sub updateClaim(ByVal myClaim As Claim)
        Dim myConn As SqlConnection = New SqlConnection(myConnString)
        myConn.Open()
        Dim myComm As SqlCommand = New SqlCommand("UPDATE claim SET reference = @reference, description = @description, amount = @amount, approved = @approved, claimDate = @claimDate, policyID = @policyID WHERE claimID = @claimID", _
            myConn)
        myComm.Parameters.AddWithValue("@claimID", myClaim.ClaimID)
        myComm.Parameters.AddWithValue("@reference", myClaim.Reference)
        myComm.Parameters.AddWithValue("@description", myClaim.Description)
        myComm.Parameters.AddWithValue("@amount", myClaim.Amount)
        If myClaim.IsApproved Then
            myComm.Parameters.AddWithValue("@approved", "Y")
        Else
            myComm.Parameters.AddWithValue("@approved", "N")
        End If
        myComm.Parameters.AddWithValue("@claimDate", myClaim.DateOfClaim)
        myComm.Parameters.AddWithValue("@policyID", myClaim.PolicyID)
        Dim rows As Integer = myComm.ExecuteNonQuery()
        myConn.Close()
        If rows <> 1 Then
            Throw New Exception("Unexpected Result for Update")
        End If
    End Sub

End Class
