﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Configuration
Imports System.Data
Imports System.Data.Sql
Imports System.Data.SqlClient
Imports System.Linq
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Xml.Linq


Public Class PolicyDAO

    Private attrMyConnString As String

    Property MyConnString() As String
        Get
            Return attrMyConnString
        End Get
        Set(ByVal Value As String)
            attrMyConnString = Value
        End Set
    End Property

    Public Sub New()
        MyConnString = ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString
    End Sub

    Public Function getPolicyList() As List(Of Policy)
        Return getPolicyList(Nothing)
    End Function

    ' fetch list of policies
    Public Function getPolicyList(ByVal whereClause As String) As List(Of Policy)
        If IsNothing(whereClause) Then
            whereClause = ""
        End If
        Dim foundPolicies As List(Of Policy) = New List(Of Policy)
        Dim myConn As SqlConnection = New SqlConnection(MyConnString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM policy " + whereClause
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        While myDR.Read()
            foundPolicies.Add(makeDTO(myDR))
            ' create new DTO and add to list 
        End While
        Return foundPolicies
    End Function

    ' fetch a policy by ID or key
    Public Function getPolicyByKey(ByVal policyKey As Integer) As Policy
        Dim myConn As SqlConnection = New SqlConnection(MyConnString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM policy WHERE (policyID=" _
            + policyKey.ToString() + ")"
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        If myDR.Read() = False Then
            Return Nothing
        End If
        Return makeDTO(myDR)
    End Function
    ' fetch a policy by policyNumber 
    Public Function getPolicyByNumber(ByVal policyNumber As Integer) As Policy
        Dim myConn As SqlConnection = New SqlConnection(MyConnString)
        myConn.Open()
        Dim mySelectStatement As String = "SELECT * FROM policy WHERE (policyNumber=" _
            + policyNumber.ToString() + ")"
        Dim myComm As SqlCommand = New SqlCommand(mySelectStatement, myConn)
        Dim myDR As SqlDataReader
        myDR = myComm.ExecuteReader()
        If myDR.Read() = False Then
            Return Nothing
        End If
        Return makeDTO(myDR)
    End Function

    ' helper method 
    Private Function makeDTO(ByVal myDR As SqlDataReader) As Policy
        Dim myPolicy As Policy = New Policy()
        myPolicy.PolicyID = myDR.GetInt32(0)
        myPolicy.Number = myDR.GetInt32(1)
        myPolicy.Type = myDR.GetString(2)
        myPolicy.StartDate = myDR.GetDateTime(3)
        myPolicy.AnnualPremium = myDR.GetDecimal(4)
        myPolicy.IsPaidUp = (myDR.GetString(5).StartsWith("Y"))
        myPolicy.PolicyHolderID = myDR.GetInt32(6)
        Return myPolicy
    End Function

    ' save a policy object to the database 
    Public Sub savePolicy(ByVal myPolicy As Policy)
        Dim myConn As SqlConnection = New SqlConnection(MyConnString)
        myConn.Open()
        Dim myComm As SqlCommand = New SqlCommand("UPDATE policy SET reference = @reference, description = @description, amount = @amount, approved = @approved, claimDate = @claimDate, policyID = @policyID WHERE claimID = @claimID", _
            myConn)
        myComm.Parameters.AddWithValue("@policyID", myPolicy.PolicyID)
        myComm.Parameters.AddWithValue("@policyNumber", myPolicy.Number)
        myComm.Parameters.AddWithValue("@policyType", myPolicy.Type)
        myComm.Parameters.AddWithValue("@startDate", myPolicy.StartDate)
        myComm.Parameters.AddWithValue("@annualPremium", myPolicy.AnnualPremium)
        If myPolicy.IsPaidUp Then
            myComm.Parameters.AddWithValue("@isPaidUp", "Y")
        Else
            myComm.Parameters.AddWithValue("@isPaidUp", "N")
        End If
        myComm.Parameters.AddWithValue("@policyHolderID", myPolicy.PolicyID)
        Dim rows As Integer = myComm.ExecuteNonQuery()
        If rows <> 1 Then
            Throw New Exception("Unexpected Result for Update")
        End If
    End Sub
End Class
